type alerte=
    Alone
  | Tranquille
  | CombatLocal of int * string list
  | ZoneDense;;

let count_robots () =
  let i = ref 0 in
  Hashtbl.iter (fun _ _ -> incr i) State.robot_locations;
  !i;;

(*
let evaluationRisques()=
  let cr = count_robots () in 
  if cr <= 1 then Alone 
  else
  let (me_x,me_y)=State.my_location() in
  let distance_robots=
    Hashtbl.fold 
      (fun r (x,y) l->(r,abs (me_x-x)+ abs(me_y-y))::l)
      State.robot_locations [] in
  let robots_pres=List.sort (fun x y->(snd x)-(snd y)) (List.filter (fun (r,d)->d<=3) distance_robots) in
  let robots_meme_position=List.filter (fun (r,d)->d=0) robots_pres in
  let robots_tres_proches= List.filter (fun (r,d)->d=1) robots_pres in
  let robots_proches= List.filter (fun (r,d)->d>1) robots_pres in
  let risque=5*(List.length robots_meme_position)
      +2*(List.length robots_tres_proches)
      +(List.length robots_proches) in
  if (List.length robots_pres)=0 then
    Tranquille
  else if (List.length robots_pres)<3 then
    CombatLocal
  else
    ZoneDense
*)

let evaluationRisques()=
  let cr = count_robots () in
  if cr <= 1 then
    Alone
  else
    let (me_x, me_y) = State.my_location () in
    let distance_robots =
      List.sort (fun (_, d) (_, d') -> compare d d')
        (Hashtbl.fold
           (fun r (x, y) l->
              if r = !State.my_id then l else
              (r, abs (me_x - x) + abs (me_y - y)) :: l)
           State.robot_locations [])
    in
    let robots_tres_proches =
      List.filter (fun (r,d)-> d <= 2) distance_robots in
    if List.length robots_tres_proches > 3 then
      ZoneDense
    else
      match distance_robots with
        (r, d) :: (r', d') :: rem when d' < 10 ->
          let scope = match rem with (_, d'') :: _ -> d'' | _ -> max_int in
          CombatLocal (scope, [r; r'])
      | (r, d) :: rem when d < 10 ->
          let scope = match rem with (_, d'') :: _ -> d'' | _ -> max_int in
          CombatLocal (scope, [r])
      | _ ->
          Tranquille


(*
XXXX
Find the closest robots.
If their distance is more than 10, then Tranquille

If there are more than two, 

Robots a une distance < 10  ==> alpha beta
*)
