
(* $Id: distance.ml,v 1.16 2002/09/02 16:31:25 emmanuel Exp $ *)
let infinite = max_int

(*
let distanceEssai1 l=
  let s= ! State.board in
  let tab=Array.make_matrix !State.w !State.h infinite in
  let fifo=Queue.create () in
  List.iter (fun (x,y)->(Queue.add (x,y,0) fifo)) l;
  while not(Queue.is_empty fifo) do
    let i,j,d=Queue.take fifo in
    let item=String.get s (i+j* !State.w) in
    if (item='.') then
      ((*print_string "+\n";*)
       if tab.(i).(j)= infinite then (
	 tab.(i).(j)<-d;
	 List.iter (fun x->Queue.add x fifo) [(i-1,j,d+1);(i+1,j,d+1);(i,j-1,d+1);(i,j+1,d+1)]
	)
      )
  done;
  tab
;;

let distance l=
  let s= ! State.board in
  let tab=Array.make_matrix !State.w !State.h infinite in
  let queue=Array.make (!State.w * !State.h) (0,0) in
  let debutQueue=ref 0 in
  let longueurQueue=ref 0 in
  let ajoutQueue x y=queue.(!debutQueue+ !longueurQueue)<-(x,y);
    longueurQueue:=!longueurQueue+1; in
  List.iter (fun (x,y)->ajoutQueue x y;tab.(x).(y)<- 0) l;
  let retireQueue()=
    longueurQueue:=!longueurQueue-1;
    debutQueue:= !debutQueue+1;
    queue.(!debutQueue-1);
  in
  while not(!longueurQueue=0) do
   let i,j=retireQueue() in
   let d=tab.(i).(j) in
    if String.get s (i-1+j* !State.w) ='.' then
      if tab.(i-1).(j)=infinite then (
	 tab.(i-1).(j)<-d+1;
	ajoutQueue (i-1) j;
       );
     if String.get s (i+1+j* !State.w) ='.' then
      if tab.(i+1).(j)=infinite then (
	 tab.(i+1).(j)<-d+1;
	ajoutQueue (i+1) j;
       );
    if String.get s (i+(j-1)* !State.w) ='.' then
      if tab.(i).(j-1)=infinite then (
	 tab.(i).(j-1)<-d+1;
	ajoutQueue i (j-1);
       );
   if String.get s (i+(j+1)* !State.w) ='.' then
      if tab.(i).(j+1)=infinite then (
	 tab.(i).(j+1)<-d+1;
	ajoutQueue i (j+1);
       );
  done;
  tab
;;
*)

let queue = ref [||]

let update_distance tab l =
  let s = !State.board in
  let w = !State.w in
  if Array.length !queue = 0 then begin
    queue := Array.make (!State.w * !State.h) 0
  end;
  let queue = !queue in
  let debutQueue = ref 0 in
  let finQueue = ref 0 in
  let ajoutQueue pos d =
    if s.[pos] = '.' && tab.(pos) > d then begin
      tab.(pos) <- d;
      queue.(!finQueue) <- pos;
      incr finQueue
    end
  in
  List.iter (fun (x, y) -> ajoutQueue (x + y * w) 0) l;
  while !debutQueue < !finQueue do
    let pos = queue.(!debutQueue) in
    incr debutQueue;
    let d = tab.(pos) + 1 in
    ajoutQueue (pos - 1) d;
    ajoutQueue (pos - w) d;
    ajoutQueue (pos + 1) d;
    ajoutQueue (pos + w) d
  done;
  tab

let distance l = update_distance (Array.make (!State.w * !State.h) infinite) l

let get_distance dist x y = dist.(x + y * !State.w)

let distance_locale x y l =
  let tab = Array.make (!State.w * !State.h) infinite in
  let s = !State.board in
  let w = !State.w in
  if Array.length !queue = 0 then begin
    queue := Array.make (!State.w * !State.h) 0
  end;
  let queue = !queue in
  let debutQueue = ref 0 in
  let finQueue = ref 0 in
  let ajoutQueue pos d =
    if s.[pos] = '.' && tab.(pos) > d then begin
      tab.(pos) <- d;
      queue.(!finQueue) <- pos;
      incr finQueue
    end
  in
  List.iter (fun (x, y) -> ajoutQueue (x + y * w) 0) l;
  while (!debutQueue < !finQueue)&&(x+y*w!=queue.(!debutQueue))do
    let pos = queue.(!debutQueue) in
    incr debutQueue;
    let d = tab.(pos) + 1 in
    ajoutQueue (pos - 1) d;
    ajoutQueue (pos - w) d;
    ajoutQueue (pos + 1) d;
    ajoutQueue (pos + w) d
  done;
  tab.(queue.(!debutQueue))

let rec plus_proche x y d= 
  let dp = get_distance d x y in
  if dp  = 0 then (x,y) 
  else 
    if get_distance d (x-1) y < dp then plus_proche (x - 1) y d 
    else if get_distance d (x+1) y < dp then plus_proche (x + 1) y d  
    else if get_distance d x (y-1) < dp then plus_proche x (y-1) d 
    else plus_proche  x (y+1) d;;



(*distance a sortie d'un carre n*n pour en reduisant une distance dist*)
(*precision_distance_bord =2 ?? *)
let distance_guepier n x y destx desty dist precision_distance_bord coup_eau coup_robot=
  let tab = Array.make_matrix (2*n+1) (2*n+1) infinite in
  let s = !State.board in
  let w = !State.w in
  let queue = Array.make ((2*n+3)*(2*n+3)) (0,0) in
  let debutQueue = ref 0 in
  let finQueue = ref 0 in
  let bord dx dy=
    (if x+dx<0 then -x else if x+dx>w then w-x else dx),
    (if y+dy<0 then -y else if y+dy> !State.h then !State.h-y else dy)
  in
  let liste_bord=ref [] in
  let liste_bord_proche_objectif=ref [] in

  let coup_voisins pos=
    if s.[pos-1] = '~' ||
    s.[pos+1] = '~' ||
    s.[pos-w] = '~' ||
    s.[pos+w] = '~' then coup_eau else 0 in
  
  let ajoutPos pos=liste_bord:=pos:: !liste_bord in
  let rec min_liste l=
    match l with
      []->max_int
    |a::l->let m=min_liste l in
      if a<m then a else m in
   let ajoutQueue x1 y1 d =
    if x1< -n || x1>n || y1< -n || y1>n then () else
    let pos=x+x1+(y+y1)*w in
    if !Debug.dist then
      begin
	print_string "+++";print_int (x1);
	print_string "+++"; print_int (y1);
	print_string "+++\n";
      end;
    if s.[pos] = '.' && tab.(n+x1).(n+y1) > d then begin
      let c=coup_voisins pos in
      tab.(n+x1).(n+y1) <- d+c;
      queue.(!finQueue) <- (x1,y1);
      incr finQueue
    end
  in

  if abs(x-destx)<n && abs(y-desty)<n then
    begin
      liste_bord_proche_objectif := [(destx-x,desty-y)];
      if !Debug.dist then begin
	print_string "objectif a l'interieur";
	print_newline();
      end;
    end
  else begin
    ajoutQueue 0 0 0;
    while (!debutQueue < !finQueue) do
      let x1,y1 = queue.(!debutQueue) in
      incr debutQueue;
      if (x1>= -n)&&(x1<=n)&&(y1>= -n)&&(y1<=n)then
	let pos = x+x1+(y+y1)*w in
	let d = tab.(n+x1).(n+y1) + 1 in
	ajoutQueue (x1-1) y1 d;
	ajoutQueue (x1+1) y1 d;
	ajoutQueue x1 (y1-1) d;
	ajoutQueue x1 (y1+1) d
    done;
    
    for i= -n to n do
      ajoutPos (bord i (-n));
      ajoutPos (bord i n);
      ajoutPos (bord n i);
      ajoutPos (bord (-n) i);
    done;
    liste_bord:=List.filter (fun (x,y)->
      tab.(n+x).(n+y)<infinite) !liste_bord;
    debutQueue:=0;
    finQueue:=0;
    for i=0 to 2*n do for j=0 to 2*n do tab.(i).(j) <- infinite done done;
        let distance_bord l=
      min_liste (List.map (fun (x1,y1)->get_distance dist (x1+x) (y1+y)) !liste_bord) in
    let distance_bord_objectif=distance_bord !liste_bord in
    liste_bord_proche_objectif :=
      List.filter (fun (x1,y1)->
	(get_distance dist (x1+x) (y1+y))<=distance_bord_objectif+precision_distance_bord) 
	!liste_bord
  end;
  if !Debug.dist then begin
    print_string "longueur listebord proche objectif";
    print_int (List.length !liste_bord_proche_objectif);
    print_string "==\n";
    List.iter (fun (x,y)->print_string ("+++"^(string_of_int x)^"ll"^(string_of_int y)^"\n"))
      !liste_bord; 
    print_newline();
  
    List.iter (fun (x,y)->print_string ("+++"^(string_of_int x)^"ll"^(string_of_int y)^"\n"))
      !liste_bord_proche_objectif; 
    print_newline();
  end;
  
  List.iter (fun (x,y)->ajoutQueue x y 0) !liste_bord_proche_objectif; 
  
(*liste des points du bord du carr*)

  while (!debutQueue < !finQueue) do
    let x1,y1 = queue.(!debutQueue) in
    incr debutQueue;
    if (x1>= -n)&&(x1<=n)&&(y1>= -n)&&(y1<=n)then
      let pos = x+x1+(y+y1)*w in
      let d = tab.(n+x1).(n+y1) + 1 in
      ajoutQueue (x1-1) y1 d;
      ajoutQueue (x1+1) y1 d;
      ajoutQueue x1 (y1-1) d;
      ajoutQueue x1 (y1+1) d
  done;
  let li=[tab.(n-1).(n);tab.(n+1).(n);tab.(n).(n-1);tab.(n).(n+1)] in
  let a=min_liste li in
  let rec choisit a l1 l2=
    match l1 with
      []->failwith "choisi bug"
    |b::l->if b=a then List.hd l2 else choisit a l (List.tl l2) in
  tab,(choisit a li ['w';'e';'s';'n'])
;;

