
(**
 $Id: select2.ml,v 1.3 2002/09/02 13:01:47 emmanuel Exp $
**)


(* choix d'un ensemble de package a' prendre sur une case qui en contient *)

(* plusieurs choix : 

    1/ on veut distribuer les packages que l'on a deja en esperant n'etre pas loin 
       a' la fin de la distribution d'un endroit ou' il y a des packages

       - soit il y a rien : on continue la distribution 
       - soit on tombe sur une case ou' il y a des packages : 

          a - on doit decider si on en prend, et si cela implique d'en laisser tomber 
              sachant que pour le calcul si on en depose on les depose tous 

              dans le cas ou'  on a rien par defaut on prend (quitte a' perdre un mouvement plus tard) 

       


*)

open State;;
open Distance;;  

type   pkg_infos = 
  {id : PackageSet.elt ; dest : State.dest ; dist : int;  value : float};;

let acces_dest pi = pi.dest;; 
let acces_dest_x pi = (acces_dest pi).x;;
let acces_dest_y pi = (acces_dest pi).y;;

let gen_eval f d x = 
  let { x = px ; y = py} as dest   = Hashtbl.find  package_dests x in 
  let dt = get_distance d px py in 
  let v =   f dest.weight dt in 
    {id = x; dest = dest ; dist = dt; value = v};;

(*
let eval_neighbors   = gen_eval (fun w d -> (float w) /. (4.0 *. (float d)));; 

let count_cap l c  = 
  let rec count_rec l c r = match l with 
  [] -> []
  | t::q -> if t.weight < c then (count_rec q (c-t.weight) (t::r))
    else if t.weight = c then t::r else []
  in 
  count_rec l c [];;
             
let neighbors eval_pkgl curr_cap = match eval_pkgl with 
  [] -> []
  | t::q -> let d = distance [t.pos] in 
   let l1 =  List.map (fun x -> eval_neighbors d x.id) q in     
   let l2 =  List.filter (fun x ->  x.weight > curr_cap)  eval_pkgl in 
     t::(List.rev (count_cap l2 (curr_cap- t.weight)));;
 
*)



let filter_select d max_money cap p = 
   let {x = px; y = py; weight = w} = p.dest in 
     (    ((get_distance d px py) <= max_money)  
       && (w <= cap))
;;


let eval_select  = gen_eval (fun w d -> (float w) /. (float d));;



let rec  select local_point local_money local_pkgl own_pkgl  own_cap   = 
  let all_pkgl = own_pkgl@local_pkgl in 
  let d = distance (local_point :: (List.map (fun z ->  z.dest.x,z.dest.y) own_pkgl)) in 

  let f_local_pkgl = List.filter (filter_select d local_money own_cap) local_pkgl in 

  let eval_pkgl =  List.map (eval_select d)  (List.map (fun x -> x.id) f_local_pkgl)    in 
  let l2 =    List.sort (fun x y -> if x.value > y.value then 1 else -1) eval_pkgl  in 
    match l2 with 
      [] -> own_pkgl 
    | h::q ->  select local_point (local_money)  q  (h::own_pkgl) (own_cap - h.dest.weight)
;;



let main_select own_pkgl  = 
  let pos = State.my_location() in 
  let l_pkgl =  Hashtbl.find packages_at_location pos in 
  let fl_pkgl = List.map (fun (x,y) -> y ) !l_pkgl in 
  let l_dest = List.map (fun x -> x,(Hashtbl.find State.package_dests x)) fl_pkgl  in
  let local_pkgl  = List.map ( fun (x,d)  -> ( {id = x; dest = d;  dist = 0;  value =0.0}) ) l_dest  in
 

  let r = List.fold_left (fun x y -> x -y) !State.max_weight (List.map (fun x -> x.dest.weight) own_pkgl) in (* 30 in *)
  let new_pkgl = select pos !State.money local_pkgl own_pkgl r  in 
   new_pkgl;;

(*
let init_eval l = st
  let d = distance [(State.my_location())] in 
  List.map 
    ( fun id -> 
        let dt = Hashtbl.find State.package_dests id in 
        let ds = get_distance d dt.x dt.y in 
        let v = eval_select dt.weight ds in  
                {id = id ; dest = dt; distance = ds; value = v }) l;;

*)




